VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'======================================================================================================

' >> Descripcin    ::  Mdulo Para guardar en una coleccin las url a descargar
' >> Autor          ::  Luciano Lodola . http://www.recursosvisualbasic.com.ar/
'======================================================================================================


Private Const SIZE_KB As Double = 1024
Private Const SIZE_MB As Double = 1024 * SIZE_KB
Private Const SIZE_GB As Double = 1024 * SIZE_MB
Private Const SIZE_TB As Double = 1024 * SIZE_GB

Private mColItems               As New Collection


' -------------------------------------------------------------------------------
' \\ - Agregar un nuevo item a la coleccin
' -------------------------------------------------------------------------------

Public Function Add(Title As String, Key As String, FileName As String, Url As String, Status As eStatus) As cDownloadItem
    
    On Error GoTo err_handler
    
    Dim mItem As New cDownloadItem
    
    With mItem
        .Key = Key
        .Title = Title
        .FileName = FileName
        .Url = Url
        .Status = eNew
        mColItems.Add mItem, Key
    End With
    
    Set Add = mItem
    Set mItem = Nothing
Exit Function
err_handler:
MsgBox Err.Description

End Function

' -------------------------------------------------------------------------------
' \\ - Cantidad de elementos de la coleccin
' -------------------------------------------------------------------------------


Property Get Count() As Long
    Count = mColItems.Count
Exit Property
err_handler:
MsgBox Err.Description
End Property

' -------------------------------------------------------------------------------
' \\ - Eliminar coleccin
' -------------------------------------------------------------------------------

Public Sub DeleteAll()
On Error GoTo err_handler

    Do Until mColItems.Count = 0
        Delete 1
    Loop
    
Exit Sub
err_handler:
MsgBox Err.Description
    
End Sub

' -------------------------------------------------------------------------------
' \\ - Eliminar item
' -------------------------------------------------------------------------------

Public Sub Delete(ByVal Index As Variant)
On Error GoTo err_handler
    
    mColItems.Remove Index

Exit Sub
err_handler:
MsgBox Err.Description
    
End Sub

' -------------------------------------------------------------------------------
' \\ - Devolver un Item ( cDownloadItem )
' -------------------------------------------------------------------------------

Public Function Item(ByVal Index As Variant) As cDownloadItem
On Error GoTo err_handler

    Set Item = mColItems.Item(Index)
    
Exit Function
err_handler:

'If Err.Number = 5 Then
    Set Item = Nothing
'Else
'    MsgBox Err.Description
'End If

End Function

' -------------------------------------------------------------------------------
' \\ - Otras funciones
' -------------------------------------------------------------------------------


Function GetStatusText(lStatus As eStatus) As String
    If lStatus = eCancel Then GetStatusText = "Cancelado"
    If lStatus = eDownloading Then GetStatusText = "Descargando"
    If lStatus = eNew Then GetStatusText = "En espera"
    If lStatus = eError Then GetStatusText = "Error"
    If lStatus = eFinished Then GetStatusText = "Listo"
    If lStatus = ePause Then GetStatusText = "Pausado"
End Function

Function CheckItemExist(sKey As String) As Boolean
    On Error Resume Next
    Dim xItem As cDownloadItem
    Set xItem = mColItems(sKey)
    If xItem Is Nothing Then
        CheckItemExist = False
    Else
        CheckItemExist = True
    End If
End Function

Private Sub Class_Terminate()
    
    
    If Not mColItems Is Nothing Then
       Set mColItems = Nothing
    End If
End Sub

' \\ Formatear los bytes en KB, MB, GB para el tamao de los archivos
' ----------------------------------------------------------------------------------------
Function GetFileSize(ByVal n_bytes As Double) As String
    If n_bytes < SIZE_KB Then
        GetFileSize = Format$(n_bytes) & " bytes"
    ElseIf n_bytes < SIZE_MB Then
        GetFileSize = Format$(n_bytes / SIZE_KB, "0.00") & " KB"
    ElseIf n_bytes < SIZE_GB Then
        GetFileSize = Format$(n_bytes / SIZE_MB, "0.00") & " MB"
    Else
        GetFileSize = Format$(n_bytes / SIZE_GB, "0.00") & " GB"
    End If
End Function

Public Function GetFormatLenght(lValue As Long) As String
    On Error GoTo error_handler
    GetFormatLenght = CStr(lValue \ 60) & ":" & Format$(lValue Mod 60, "00")

Exit Function
error_handler:

End Function
