VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSubclassToolBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Name...........cSubclassToolBar
'Author.........Leandro Ascierto leandroascierto@hotmail.com
'Date...........07/07/2008
'------------------------------------------------------
'modulo Subclass
'Name.......... cSuperClass
'Author........ Paul_Caton@hotmail.com
'Date.......... June, 13th 2002


Option Explicit

Private Enum eMsgWhen                                                     'When to callback
    MSG_BEFORE = 1                                                        'Callback before the original WndProc
    MSG_AFTER = 2                                                         'Callback after the original WndProc
    MSG_BEFORE_AFTER = MSG_BEFORE Or MSG_AFTER                            'Callback before and after the original WndProc
End Enum

Private Enum eThunkType
    SubclassThunk = 0
    HookThunk = 1
    CallbackThunk = 2
End Enum

Private z_IDEflag           As Long         'Flag indicating we are in IDE
Private z_ScMem             As Long         'Thunk base address
Private z_scFunk            As Collection   'hWnd/thunk-address collection
Private z_hkFunk            As Collection   'hook/thunk-address collection
Private z_cbFunk            As Collection   'callback/thunk-address collection
Private Const IDX_INDEX     As Long = 2     'index of the subclassed hWnd OR hook type
Private Const IDX_CALLBACKORDINAL As Long = 22 ' Ubound(callback thunkdata)+1, index of the callback

Private Const IDX_WNDPROC   As Long = 9     'Thunk data index of the original WndProc
Private Const IDX_BTABLE    As Long = 11    'Thunk data index of the Before table
Private Const IDX_ATABLE    As Long = 12    'Thunk data index of the After table
Private Const IDX_PARM_USER As Long = 13    'Thunk data index of the User-defined callback parameter data index
Private Const IDX_UNICODE   As Long = 75    'Must be Ubound(subclass thunkdata)+1; index for unicode support
Private Const ALL_MESSAGES  As Long = -1    'All messages callback
Private Const MSG_ENTRIES   As Long = 32    'Number of msg table entries. Set to 1 if using ALL_MESSAGES for all subclassed windows

Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal Destination As Long, ByVal Source As Long, ByVal Length As Long)
Private Declare Function IsBadCodePtr Lib "kernel32" (ByVal lpFn As Long) As Long
Private Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
Private Declare Function GetModuleHandleA Lib "kernel32" (ByVal lpModuleName As String) As Long
Private Declare Function GetModuleHandleW Lib "kernel32" (ByVal lpModuleName As Long) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function CallWindowProcW Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function IsWindowUnicode Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function SendMessageA Lib "user32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function SendMessageW Lib "user32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function SetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowLongW Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'==============================* cSubclassToolBar *===========================
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function EndPaint Lib "user32" (ByVal hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function BeginPaint Lib "user32" (ByVal hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function PtInRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
'Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As Size) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, ByVal y As Long, ByVal fStyle As Long) As Long
Private Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal himl As Long, ByRef cx As Long, ByRef cy As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hdc As Long, ByVal lpsz As String, ByVal n As Long, lpRect As RECT, ByVal un As Long, ByVal lpDrawTextParams As Any) As Long
Private Declare Function ImageList_GetIcon Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal flags As Long) As Long
Private Declare Function DrawState Lib "user32" Alias "DrawStateA" (ByVal hdc As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lParam As Long, ByVal wParam As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal flags As Long) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function RedrawWindow Lib "user32" (ByVal hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
'Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
'---------

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type Size
    cx As Long
    cy As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type PAINTSTRUCT
    hdc                     As Long
    fErase                  As Long
    rcPaint                 As RECT
    fRestore                As Long
    fIncUpdate              As Long
    rgbReserved(1 To 32)    As Byte
End Type

Private Type TBBUTTONINFO
   cbSize As Long
   dwMask As Long
   idCommand As Long
   iImage As Long
   fsState As Byte
   fsStyle As Byte
   cx As Integer
   lParam As Long  '
   pszText As String
   cchText As Long
End Type

Const DST_ICON = &H3
Const DST_BITMAP = &H4
Const DSS_DISABLED = &H20

Const WM_USER = &H400
Const WM_GETFONT As Long = &H31
Const WM_PAINT As Long = &HF&
Const WM_SETFONT As Long = &H30
Const WM_ERASEBKGND As Long = &H14

Const DT_RIGHT As Long = &H2
Const DT_CENTER = &H1
Const DT_WORDBREAK = &H10
Const TRANSPARENT = 1
Const GWL_WNDPROC = -4
Const ILD_TRANSPARENT = &H1

Const TB_BUTTONCOUNT = (WM_USER + 24)
Const TB_GETITEMRECT = (WM_USER + 29)
Const TB_GETBUTTONTEXTA = (WM_USER + 45)
Const TB_GETIMAGELIST = (WM_USER + 49)
Const TB_GETHOTIMAGELIST = (WM_USER + 53)
Const TB_GETDISABLEDIMAGELIST = (WM_USER + 55)
Const TB_GETBUTTONINFOA = (WM_USER + 65)
Const TB_SETSTYLE = WM_USER + 56
Const TB_GETSTYLE = WM_USER + 57

Const TBIF_IMAGE = &H1
Const TBIF_TEXT = &H2
Const TBIF_STATE = &H4
Const TBIF_STYLE = &H8
Const TBIF_LPARAM = &H10
Const TBIF_COMMAND = &H20
Const TBIF_SIZE = &H40
Const TBIF_BYINDEX = &H80000000
Const TBIF_ALL = TBIF_IMAGE Or TBIF_STATE Or _
                         TBIF_STYLE Or TBIF_LPARAM Or TBIF_COMMAND _
                         Or TBIF_SIZE Or TBIF_BYINDEX 'Or TBIF_TEXT

Const TBSTYLE_FLAT As Long = &H800
Const TBSTYLE_LIST As Long = &H1000
Const TBSTYLE_SEP As Long = &H1
Const TBSTYLE_DROPDOWN As Long = &H8
Const TBSTYLE_GROUP As Long = &H4
Const TBSTYLE_CHECK As Long = &H2
Const TBSTYLE_CHECKGROUP As Long = (TBSTYLE_GROUP Or TBSTYLE_CHECK)

Const TBSTATE_CHECKED As Long = &H1
Const TBSTATE_ENABLED As Long = &H4
Const TBSTATE_PRESSED As Long = &H2
Const TBSTATE_HIDDEN As Long = &H8



Private Enum ButtonType 'de uso interno(inventado)
    Default = 0
    Separator = 1
    SplitButton = 4
    SplitButtonDropDown = 8
End Enum
    
Private Enum ButtonState 'de uso interno(inventado)
    TS_HOT = 0
    TS_PRESSED = 1
    TS_CHECKED = 2
    TS_HOTCHECKED = 3
End Enum

Const SkinBtnBorderW = 5
Const SkinBtnBorderH = 5
Const SpitBtnWidth = 13
Const SkinBtnWidth = 15
Const SkinBtnHeight = 23
Const AjustBtnHeight = 2

Private hSkin As Long
Private m_CommonControls6 As Boolean
Private m_TextAlignRight As Boolean
Private hToolbar As Long
Private m_TextNormalColor As Long
Private m_TextResalteColor As Long
Private m_TextDisabledColor As Long
Private m_OldStyle As Long


Sub Refresh()
    If hToolbar Then RedrawWindow hToolbar, ByVal 0&, ByVal 0&, &H1
End Sub

Private Sub Class_Terminate()
    UnSubClassToolBar
    If hSkin Then DeleteDC hSkin
End Sub

Public Sub UnSubClassToolBar(Optional Restore As Boolean)
    'SetWindowLong hToolbar, GWL_WNDPROC, PrevProc
    ssc_Terminate
    scb_TerminateCallbacks
    If Restore Then SendMessageLong hToolbar, TB_SETSTYLE, 0, m_OldStyle
    hToolbar = 0
End Sub

Public Sub SetSkinPicture(Pic As StdPicture)

    If hSkin Then DeleteDC hSkin
    hSkin = CreateCompatibleDC(0)
    Call SelectObject(hSkin, Pic.Handle)
    
    m_TextNormalColor = GetPixel(hSkin, 215, 0)
    m_TextResalteColor = GetPixel(hSkin, 215, 6)
    m_TextDisabledColor = GetPixel(hSkin, 215, 10)

    If hToolbar Then RedrawWindow hToolbar, ByVal 0&, ByVal 0&, &H1
End Sub

Function SetTextColors(lTextNormalColor As Long, lTextResalteColor As Long, lTextDisabledColor As Long)
    m_TextNormalColor = lTextNormalColor
    m_TextResalteColor = lTextResalteColor
    m_TextDisabledColor = lTextDisabledColor
End Function

Public Function SubClassToolBar(ByVal hwnd As Long, Optional ForceTextAlignRight As Boolean) As Boolean
   
    If hToolbar Then UnSubClassToolBar
    
    hToolbar = FindWindowEx(hwnd, 0, "ToolbarWindow32", vbNullString)
    
    If hToolbar <> 0 Then
        m_CommonControls6 = False
    Else
        hToolbar = FindWindowEx(hwnd, 0, "msvb_lib_toolbar", vbNullString)
        If hToolbar = 0 Then Exit Function
        m_CommonControls6 = True
    End If
   

    m_OldStyle = SendMessageLong(hToolbar, TB_GETSTYLE, 0&, 0&)
    
    If ForceTextAlignRight Then
        m_TextAlignRight = True
        SendMessageLong hToolbar, TB_SETSTYLE, 0, m_OldStyle Or TBSTYLE_FLAT Or TBSTYLE_LIST
    Else
         m_TextAlignRight = (m_OldStyle And TBSTYLE_LIST) = TBSTYLE_LIST
        SendMessageLong hToolbar, TB_SETSTYLE, 0, m_OldStyle Or TBSTYLE_FLAT
    End If
   
    
    If ssc_Subclass(hToolbar) Then
        ssc_AddMsg hToolbar, WM_PAINT, MSG_BEFORE
        ssc_AddMsg hToolbar, WM_ERASEBKGND, MSG_BEFORE
        SubClassToolBar = True
    End If

    'PrevProc = SetWindowLong(hToolbar, GWL_WNDPROC, AddressOf WindowProc)
End Function




'=================================================



'-The following routines are exclusively for the ssc_subclass routines----------------------------
Private Function ssc_Subclass(ByVal lng_hWnd As Long, _
       Optional ByVal lParamUser As Long = 0, _
       Optional ByVal nOrdinal As Long = 1, _
       Optional ByVal oCallback As Object = Nothing, _
       Optional ByVal bIdeSafety As Boolean = True, _
       Optional ByVal bUnicode As Boolean = False) As Boolean 'Subclass the specified window handle

    '*************************************************************************************************
    '* lng_hWnd   - Handle of the window to subclass
    '* lParamUser - Optional, user-defined callback parameter
    '* nOrdinal   - Optional, ordinal index of the callback procedure. 1 = last private method, 2 = second last private method, etc.
    '* oCallback  - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety - Optional, enable/disable IDE safety measures. NB: you should really only disable IDE safety in a UserControl for design-time subclassing
    '* bUnicode - Optional, if True, Unicode API calls will be made to the window vs ANSI calls
    '*************************************************************************************************
    '* cSelfSub - self-subclassing class template
    '* Paul_Caton@hotmail.com
    '* Copyright free, use and abuse as you see fit.
    '*
    '* v1.0 Re-write of the SelfSub/WinSubHook-2 submission to Planet Source Code............ 20060322
    '* v1.1 VirtualAlloc memory to prevent Data Execution Prevention faults on Win64......... 20060324
    '* v1.2 Thunk redesigned to handle unsubclassing and memory release...................... 20060325
    '* v1.3 Data array scrapped in favour of property accessors.............................. 20060405
    '* v1.4 Optional IDE protection added
    '*      User-defined callback parameter added
    '*      All user routines that pass in a hWnd get additional validation
    '*      End removed from zError.......................................................... 20060411
    '* v1.5 Added nOrdinal parameter to ssc_Subclass
    '*      Switched machine-code array from Currency to Long................................ 20060412
    '* v1.6 Added an optional callback target object
    '*      Added an IsBadCodePtr on the callback address in the thunk prior to callback..... 20060413
    '*************************************************************************************************
    ' Subclassing procedure must be declared identical to the one at the end of this class (Sample at Ordinal #1)

    ' \\LaVolpe - reworked routine a bit, revised the ASM to allow auto-unsubclass on WM_DESTROY
    Dim z_Sc(0 To IDX_UNICODE) As Long                 'Thunk machine-code initialised here
    Const CODE_LEN      As Long = 4 * IDX_UNICODE      'Thunk length in bytes
    
    Const MEM_LEN       As Long = CODE_LEN + (8 * (MSG_ENTRIES))  'Bytes to allocate per thunk, data + code + msg tables
    Const PAGE_RWX      As Long = &H40&                'Allocate executable memory
    Const MEM_COMMIT    As Long = &H1000&              'Commit allocated memory
    Const MEM_RELEASE   As Long = &H8000&              'Release allocated memory flag
    Const IDX_EBMODE    As Long = 3                    'Thunk data index of the EbMode function address
    Const IDX_CWP       As Long = 4                    'Thunk data index of the CallWindowProc function address
    Const IDX_SWL       As Long = 5                    'Thunk data index of the SetWindowsLong function address
    Const IDX_FREE      As Long = 6                    'Thunk data index of the VirtualFree function address
    Const IDX_BADPTR    As Long = 7                    'Thunk data index of the IsBadCodePtr function address
    Const IDX_OWNER     As Long = 8                    'Thunk data index of the Owner object's vTable address
    Const IDX_CALLBACK  As Long = 10                   'Thunk data index of the callback method address
    Const IDX_EBX       As Long = 16                   'Thunk code patch index of the thunk data
    Const GWL_WNDPROC   As Long = -4                   'SetWindowsLong WndProc index
    Const WNDPROC_OFF   As Long = &H38                 'Thunk offset to the WndProc execution address
    Const SUB_NAME      As String = "ssc_Subclass"     'This routine's name
    
    Dim nAddr         As Long
    Dim nID           As Long
    Dim nMyID         As Long

    If IsWindow(lng_hWnd) = 0 Then                      'Ensure the window handle is valid
        zError SUB_NAME, "Invalid window handle"
        Exit Function
    End If
    
    nMyID = GetCurrentProcessId                         'Get this process's ID
    GetWindowThreadProcessId lng_hWnd, nID              'Get the process ID associated with the window handle
    If nID <> nMyID Then                                'Ensure that the window handle doesn't belong to another process
        zError SUB_NAME, "Window handle belongs to another process"
        Exit Function
    End If
      
    If oCallback Is Nothing Then Set oCallback = Me     'If the user hasn't specified the callback owner
    
    nAddr = zAddressOf(oCallback, nOrdinal)             'Get the address of the specified ordinal method
    If nAddr = 0 Then                                   'Ensure that we've found the ordinal method
        zError SUB_NAME, "Callback method not found"
        Exit Function
    End If
        
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX) 'Allocate executable memory
    
    If z_ScMem <> 0 Then                                  'Ensure the allocation succeeded
  
        If z_scFunk Is Nothing Then Set z_scFunk = New Collection 'If this is the first time through, do the one-time initialization
        On Error GoTo CatchDoubleSub                              'Catch double subclassing
        z_scFunk.Add z_ScMem, "h" & lng_hWnd                    'Add the hWnd/thunk-address to the collection
        On Error GoTo 0
        
        ' \\Tai Chi Minh Ralph Eastwood - fixed bug where the MSG_AFTER was not being honored
        ' \\LaVolpe - modified thunks to allow auto-unsubclassing when WM_DESTROY received
        z_Sc(14) = &HD231C031: z_Sc(15) = &HBBE58960: z_Sc(16) = &H12345678: z_Sc(17) = &HF63103FF: z_Sc(18) = &H750C4339: z_Sc(19) = &H7B8B4A38: z_Sc(20) = &H95E82C: z_Sc(21) = &H7D810000: z_Sc(22) = &H228&: z_Sc(23) = &HC70C7500: z_Sc(24) = &H20443: z_Sc(25) = &H5E90000: z_Sc(26) = &H39000000: z_Sc(27) = &HF751475: z_Sc(28) = &H25E8&: z_Sc(29) = &H8BD23100: z_Sc(30) = &H6CE8307B: z_Sc(31) = &HFF000000: z_Sc(32) = &H10C2610B: z_Sc(33) = &HC53FF00: z_Sc(34) = &H13D&: z_Sc(35) = &H85BE7400: z_Sc(36) = &HE82A74C0: z_Sc(37) = &H2&: z_Sc(38) = &H75FFE5EB: z_Sc(39) = &H2C75FF30: z_Sc(40) = &HFF2875FF: z_Sc(41) = &H73FF2475: z_Sc(42) = &H1053FF24: z_Sc(43) = &H811C4589: z_Sc(44) = &H13B&: z_Sc(45) = &H39727500:
        z_Sc(46) = &H6D740473: z_Sc(47) = &H2473FF58: z_Sc(48) = &HFFFFFC68: z_Sc(49) = &H873FFFF: z_Sc(50) = &H891453FF: z_Sc(51) = &H7589285D: z_Sc(52) = &H3045C72C: z_Sc(53) = &H8000&: z_Sc(54) = &H8920458B: z_Sc(55) = &H4589145D: z_Sc(56) = &HC4816124: z_Sc(57) = &H4&: z_Sc(58) = &H8B1862FF: z_Sc(59) = &H853AE30F: z_Sc(60) = &H810D78C9: z_Sc(61) = &H4C7&: z_Sc(62) = &H28458B00: z_Sc(63) = &H2975AFF2: z_Sc(64) = &H2873FF52: z_Sc(65) = &H5A1C53FF: z_Sc(66) = &H438D1F75: z_Sc(67) = &H144D8D34: z_Sc(68) = &H1C458D50: z_Sc(69) = &HFF3075FF: z_Sc(70) = &H75FF2C75: z_Sc(71) = &H873FF28: z_Sc(72) = &HFF525150: z_Sc(73) = &H53FF2073: z_Sc(74) = &HC328C328
        
        z_Sc(IDX_EBX) = z_ScMem                                                 'Patch the thunk data address
        z_Sc(IDX_INDEX) = lng_hWnd                                               'Store the window handle in the thunk data
        z_Sc(IDX_BTABLE) = z_ScMem + CODE_LEN                                   'Store the address of the before table in the thunk data
        z_Sc(IDX_ATABLE) = z_ScMem + CODE_LEN + ((MSG_ENTRIES + 1) * 4)         'Store the address of the after table in the thunk data
        z_Sc(IDX_OWNER) = ObjPtr(oCallback)                                     'Store the callback owner's object address in the thunk data
        z_Sc(IDX_CALLBACK) = nAddr                                              'Store the callback address in the thunk data
        z_Sc(IDX_PARM_USER) = lParamUser                                        'Store the lParamUser callback parameter in the thunk data
        
        ' \\LaVolpe - validate unicode request & cache unicode usage
        If bUnicode Then bUnicode = (IsWindowUnicode(lng_hWnd) <> 0&)
        z_Sc(IDX_UNICODE) = bUnicode                                            'Store whether the window is using unicode calls or not
        
        ' \\LaVolpe - added extra parameter "bUnicode" to the zFnAddr calls
        z_Sc(IDX_FREE) = zFnAddr("kernel32", "VirtualFree", bUnicode)           'Store the VirtualFree function address in the thunk data
        z_Sc(IDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", bUnicode)        'Store the IsBadCodePtr function address in the thunk data
        
        Debug.Assert zInIDE
        If bIdeSafety = True And z_IDEflag = 1 Then                             'If the user wants IDE protection
            z_Sc(IDX_EBMODE) = zFnAddr("vba6", "EbMode", bUnicode)                'Store the EbMode function address in the thunk data
        End If
    
        ' \\LaVolpe - use ANSI for non-unicode usage, else use WideChar calls
        If bUnicode Then
            z_Sc(IDX_CWP) = zFnAddr("user32", "CallWindowProcW", bUnicode)          'Store CallWindowProc function address in the thunk data
            z_Sc(IDX_SWL) = zFnAddr("user32", "SetWindowLongW", bUnicode)           'Store the SetWindowLong function address in the thunk data
            z_Sc(IDX_UNICODE) = 1
            RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), CODE_LEN                        'Copy the thunk code/data to the allocated memory
            nAddr = SetWindowLongW(lng_hWnd, GWL_WNDPROC, z_ScMem + WNDPROC_OFF)    'Set the new WndProc, return the address of the original WndProc
        Else
            z_Sc(IDX_CWP) = zFnAddr("user32", "CallWindowProcA", bUnicode)          'Store CallWindowProc function address in the thunk data
            z_Sc(IDX_SWL) = zFnAddr("user32", "SetWindowLongA", bUnicode)           'Store the SetWindowLong function address in the thunk data
            RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), CODE_LEN                        'Copy the thunk code/data to the allocated memory
            nAddr = SetWindowLongA(lng_hWnd, GWL_WNDPROC, z_ScMem + WNDPROC_OFF)    'Set the new WndProc, return the address of the original WndProc
        End If
        If nAddr = 0 Then                                                           'Ensure the new WndProc was set correctly
            zError SUB_NAME, "SetWindowLong failed, error #" & Err.LastDllError
            GoTo ReleaseMemory
        End If
        'Store the original WndProc address in the thunk data
        RtlMoveMemory z_ScMem + IDX_WNDPROC * 4, VarPtr(nAddr), 4&              ' z_Sc(IDX_WNDPROC) = nAddr
        ssc_Subclass = True                                                     'Indicate success
    Else
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError
    End If

    Exit Function                                                             'Exit ssc_Subclass
    
CatchDoubleSub:
    zError SUB_NAME, "Window handle is already subclassed"
      
ReleaseMemory:
    VirtualFree z_ScMem, 0, MEM_RELEASE                                       'ssc_Subclass has failed after memory allocation, so release the memory
End Function

'Terminate all subclassing
Private Sub ssc_Terminate()
    ' can be made public. Releases all subclassing
    ' can be removed and zTerminateThunks can be called directly
    zTerminateThunks SubclassThunk
End Sub

'UnSubclass the specified window handle
Private Sub ssc_UnSubclass(ByVal lng_hWnd As Long)
    ' can be made public. Releases a specific subclass
    ' can be removed and zUnThunk can be called directly
    zUnThunk lng_hWnd, SubclassThunk
End Sub

'Add the message value to the window handle's specified callback table
Private Sub ssc_AddMsg(ByVal lng_hWnd As Long, ByVal uMsg As Long, Optional ByVal When As eMsgWhen = MSG_AFTER)
    ' Note: can be removed if not needed and zAddMsg can be called directly
    If IsBadCodePtr(zMap_VFunction(lng_hWnd, SubclassThunk)) = 0 Then                 'Ensure that the thunk hasn't already released its memory
        If When And MSG_BEFORE Then                                             'If the message is to be added to the before original WndProc table...
            zAddMsg uMsg, IDX_BTABLE                                              'Add the message to the before table
        End If
        If When And MSG_AFTER Then                                              'If message is to be added to the after original WndProc table...
            zAddMsg uMsg, IDX_ATABLE                                              'Add the message to the after table
        End If
    End If
End Sub

'Delete the message value from the window handle's specified callback table
Private Sub ssc_DelMsg(ByVal lng_hWnd As Long, ByVal uMsg As Long, Optional ByVal When As eMsgWhen = MSG_AFTER)
    ' Note: can be removed if not needed and zDelMsg can be called directly
    If IsBadCodePtr(zMap_VFunction(lng_hWnd, SubclassThunk)) = 0 Then                'Ensure that the thunk hasn't already released its memory
        If When And MSG_BEFORE Then                                             'If the message is to be deleted from the before original WndProc table...
            zDelMsg uMsg, IDX_BTABLE                                              'Delete the message from the before table
        End If
        If When And MSG_AFTER Then                                              'If the message is to be deleted from the after original WndProc table...
            zDelMsg uMsg, IDX_ATABLE                                              'Delete the message from the after table
        End If
    End If
End Sub

'Call the original WndProc
Private Function ssc_CallOrigWndProc(ByVal lng_hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    ' Note: can be removed if you do not use this function inside of your window procedure
    If IsBadCodePtr(zMap_VFunction(lng_hWnd, SubclassThunk)) = 0 Then            'Ensure that the thunk hasn't already released its memory
        If zData(IDX_UNICODE) Then
            ssc_CallOrigWndProc = CallWindowProcW(zData(IDX_WNDPROC), lng_hWnd, uMsg, wParam, lParam) 'Call the original WndProc of the passed window handle parameter
        Else
            ssc_CallOrigWndProc = CallWindowProcA(zData(IDX_WNDPROC), lng_hWnd, uMsg, wParam, lParam) 'Call the original WndProc of the passed window handle parameter
        End If
    End If
End Function

'Get the subclasser lParamUser callback parameter
Private Function zGet_lParamUser(ByVal hWnd_Hook_ID As Long, vType As eThunkType) As Long
    'Note: can be removed if you never need to retrieve/update your user-defined paramter. See ssc_Subclass
    If vType <> CallbackThunk Then
        If IsBadCodePtr(zMap_VFunction(hWnd_Hook_ID, vType)) = 0 Then        'Ensure that the thunk hasn't already released its memory
            zGet_lParamUser = zData(IDX_PARM_USER)                                'Get the lParamUser callback parameter
        End If
    End If
End Function

'Let the subclasser lParamUser callback parameter
Private Sub zSet_lParamUser(ByVal hWnd_Hook_ID As Long, vType As eThunkType, newValue As Long)
    'Note: can be removed if you never need to retrieve/update your user-defined paramter. See ssc_Subclass
    If vType <> CallbackThunk Then
        If IsBadCodePtr(zMap_VFunction(hWnd_Hook_ID, vType)) = 0 Then          'Ensure that the thunk hasn't already released its memory
            zData(IDX_PARM_USER) = newValue                                         'Set the lParamUser callback parameter
        End If
    End If
End Sub

'Add the message to the specified table of the window handle
Private Sub zAddMsg(ByVal uMsg As Long, ByVal nTable As Long)
    Dim nCount As Long                                                        'Table entry count
    Dim nBase  As Long                                                        'Remember z_ScMem
    Dim i      As Long                                                        'Loop index
    
    nBase = z_ScMem                                                           'Remember z_ScMem so that we can restore its value on exit
    z_ScMem = zData(nTable)                                                   'Map zData() to the specified table
    
    If uMsg = ALL_MESSAGES Then                                               'If ALL_MESSAGES are being added to the table...
        nCount = ALL_MESSAGES                                                   'Set the table entry count to ALL_MESSAGES
    Else
        nCount = zData(0)                                                       'Get the current table entry count
        If nCount >= MSG_ENTRIES Then                                           'Check for message table overflow
            zError "zAddMsg", "Message table overflow. Either increase the value of Const MSG_ENTRIES or use ALL_MESSAGES instead of specific message values"
            GoTo Bail
        End If
    
        For i = 1 To nCount                                                     'Loop through the table entries
            If zData(i) = 0 Then                                                  'If the element is free...
                zData(i) = uMsg                                                     'Use this element
                GoTo Bail                                                           'Bail
            ElseIf zData(i) = uMsg Then                                           'If the message is already in the table...
                GoTo Bail                                                           'Bail
            End If
        Next i                                                                  'Next message table entry
    
        nCount = i                                                              'On drop through: i = nCount + 1, the new table entry count
        zData(nCount) = uMsg                                                    'Store the message in the appended table entry
    End If
    
    zData(0) = nCount                                                         'Store the new table entry count
Bail:
    z_ScMem = nBase                                                           'Restore the value of z_ScMem
End Sub

'Delete the message from the specified table of the window handle
Private Sub zDelMsg(ByVal uMsg As Long, ByVal nTable As Long)
    Dim nCount As Long                                                        'Table entry count
    Dim nBase  As Long                                                        'Remember z_ScMem
    Dim i      As Long                                                        'Loop index
    
    nBase = z_ScMem                                                           'Remember z_ScMem so that we can restore its value on exit
    z_ScMem = zData(nTable)                                                   'Map zData() to the specified table
    
    If uMsg = ALL_MESSAGES Then                                               'If ALL_MESSAGES are being deleted from the table...
        zData(0) = 0                                                            'Zero the table entry count
    Else
        nCount = zData(0)                                                       'Get the table entry count
        
        For i = 1 To nCount                                                     'Loop through the table entries
            If zData(i) = uMsg Then                                               'If the message is found...
                zData(i) = 0                                                        'Null the msg value -- also frees the element for re-use
                GoTo Bail                                                           'Bail
            End If
        Next i                                                                  'Next message table entry
        
        zError "zDelMsg", "Message &H" & Hex$(uMsg) & " not found in table"
    End If
      
Bail:
    z_ScMem = nBase                                                           'Restore the value of z_ScMem
End Sub

'-SelfCallback code------------------------------------------------------------------------------------
'-The following routines are exclusively for the scb_SetCallbackAddr routines----------------------------
Private Function scb_SetCallbackAddr(ByVal nParamCount As Long, _
       Optional ByVal nOrdinal As Long = 1, _
       Optional ByVal oCallback As Object = Nothing, _
       Optional ByVal bIdeSafety As Boolean = True) As Long   'Return the address of the specified callback thunk
    '*************************************************************************************************
    '* nParamCount  - The number of parameters that will callback
    '* nOrdinal     - Callback ordinal number, the final private method is ordinal 1, the second last is ordinal 2, etc...
    '* oCallback    - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety   - Optional, set to false to disable IDE protection.
    '*************************************************************************************************
    ' Callback procedure must return a Long even if, per MSDN, the callback procedure is a Sub vs Function
    ' The number of parameters are dependent on the individual callback procedures
    
    Const MEM_LEN     As Long = IDX_CALLBACKORDINAL * 4 + 4     'Memory bytes required for the callback thunk
    Const PAGE_RWX    As Long = &H40&                           'Allocate executable memory
    Const MEM_COMMIT  As Long = &H1000&                         'Commit allocated memory
    Const SUB_NAME      As String = "scb_SetCallbackAddr"       'This routine's name
    Const INDX_OWNER    As Long = 0
    Const INDX_CALLBACK As Long = 1
    Const INDX_EBMODE   As Long = 2
    Const INDX_BADPTR   As Long = 3
    Const INDX_EBX      As Long = 5
    Const INDX_PARAMS   As Long = 12
    Const INDX_PARAMLEN As Long = 17

    Dim z_Cb()    As Long    'Callback thunk array
    Dim nCallback As Long
      
    If z_cbFunk Is Nothing Then
        Set z_cbFunk = New Collection           'If this is the first time through, do the one-time initialization
    Else
        On Error Resume Next                    'Catch already initialized?
        z_ScMem = z_cbFunk.item("h" & nOrdinal) 'Test it
        If Err = 0 Then
            scb_SetCallbackAddr = z_ScMem + 16  'we had this one, just reference it
            Exit Function
        End If
        On Error GoTo 0
    End If
    
    If nParamCount < 0 Then                     ' validate parameters
        zError SUB_NAME, "Invalid Parameter count"
        Exit Function
    End If
    
    If oCallback Is Nothing Then Set oCallback = Me     'If the user hasn't specified the callback owner
    nCallback = zAddressOf(oCallback, nOrdinal)         'Get the callback address of the specified ordinal
    If nCallback = 0 Then
        zError SUB_NAME, "Callback address not found."
        Exit Function
    End If
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX) 'Allocate executable memory
        
    If z_ScMem = 0& Then
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError  ' oops
        Exit Function
    End If
    z_cbFunk.Add z_ScMem, "h" & nOrdinal                  'Add the callback/thunk-address to the collection
        
    ReDim z_Cb(0 To IDX_CALLBACKORDINAL) As Long          'Allocate for the machine-code array
    
    ' Create machine-code array
    z_Cb(4) = &HBB60E089: z_Cb(6) = &H73FFC589: z_Cb(7) = &HC53FF04: z_Cb(8) = &H7B831F75: z_Cb(9) = &H20750008: z_Cb(10) = &HE883E889: z_Cb(11) = &HB9905004: z_Cb(13) = &H74FF06E3: z_Cb(14) = &HFAE2008D: z_Cb(15) = &H53FF33FF: z_Cb(16) = &HC2906104: z_Cb(18) = &H830853FF: z_Cb(19) = &HD87401F8: z_Cb(20) = &H4589C031: z_Cb(21) = &HEAEBFC
    
    z_Cb(INDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", False)
    z_Cb(INDX_OWNER) = ObjPtr(oCallback)                  'Set the Owner
    z_Cb(INDX_CALLBACK) = nCallback                       'Set the callback address
    z_Cb(IDX_CALLBACKORDINAL) = nOrdinal                  'Cache ordinal used for zTerminateThunks
      
    Debug.Assert zInIDE
    If bIdeSafety = True And z_IDEflag = 1 Then             'If the user wants IDE protection
        z_Cb(INDX_EBMODE) = zFnAddr("vba6", "EbMode", False)  'EbMode Address
    End If
        
    z_Cb(INDX_PARAMS) = nParamCount                         'Set the parameter count
    z_Cb(INDX_PARAMLEN) = nParamCount * 4                   'Set the number of stck bytes to release on thunk return
      
    '\\LaVolpe - redirect address to proper location in virtual memory. Was: z_Cb(INDX_EBX) = VarPtr(z_Cb(INDX_OWNER))
    z_Cb(INDX_EBX) = z_ScMem                                'Set the data address relative to virtual memory pointer
      
    RtlMoveMemory z_ScMem, VarPtr(z_Cb(INDX_OWNER)), MEM_LEN 'Copy thunk code to executable memory
    scb_SetCallbackAddr = z_ScMem + 16                       'Thunk code start address
    
End Function

Private Sub scb_ReleaseCallback(ByVal nOrdinal As Long)
    ' can be made public. Releases a specific callback
    ' can be removed and zUnThunk can be called directly
    zUnThunk nOrdinal, CallbackThunk
End Sub
Private Sub scb_TerminateCallbacks()
    ' can be made public. Releases all callbacks
    ' can be removed and zTerminateThunks can be called directly
    zTerminateThunks CallbackThunk
End Sub


'========================================================================
' COMMON USE ROUTINES
'-The following routines are used for each of the three types of thunks
'========================================================================

'Map zData() to the thunk address for the specified window handle
Private Function zMap_VFunction(ByVal vFuncTarget As Long, vType As eThunkType) As Long
    
    ' vFuncTarget is one of the following, depending on vType
    '   - Subclassing:  the hWnd of the window subclassed
    '   - Hooking:      the hook type created
    '   - Callbacks:    the ordinal of the callback
    
    Dim thunkCol As Collection
    
    If vType = CallbackThunk Then
        Set thunkCol = z_cbFunk
    ElseIf vType = HookThunk Then
        Set thunkCol = z_hkFunk
    ElseIf vType = SubclassThunk Then
        Set thunkCol = z_scFunk
    Else
        zError "zMap_Vfunction", "Invalid thunk type passed"
        Exit Function
    End If
    
    If thunkCol Is Nothing Then
        zError "zMap_VFunction", "Thunk hasn't been initialized"
    Else
        On Error GoTo Catch
        z_ScMem = thunkCol("h" & vFuncTarget)                    'Get the thunk address
        zMap_VFunction = z_ScMem
    End If
    Exit Function                                               'Exit returning the thunk address
    
Catch:
    zError "zMap_VFunction", "Thunk type for ID of " & vFuncTarget & " does not exist"
End Function

'Error handler
Private Sub zError(ByVal sRoutine As String, ByVal sMsg As String)
    ' \\LaVolpe -  Note. These two lines can be rem'd out if you so desire. But don't remove the routine
    App.LogEvent TypeName(Me) & "." & sRoutine & ": " & sMsg, vbLogEventTypeError
    MsgBox sMsg & ".", vbExclamation + vbApplicationModal, "Error in " & TypeName(Me) & "." & sRoutine
End Sub

'Return the address of the specified DLL/procedure
Private Function zFnAddr(ByVal sDLL As String, ByVal sProc As String, ByVal asUnicode As Boolean) As Long
    If asUnicode Then
        zFnAddr = GetProcAddress(GetModuleHandleW(StrPtr(sDLL)), sProc)         'Get the specified procedure address
    Else
        zFnAddr = GetProcAddress(GetModuleHandleA(sDLL), sProc)                 'Get the specified procedure address
    End If
    Debug.Assert zFnAddr                                                      'In the IDE, validate that the procedure address was located
    ' ^^ FYI VB5 users. Search for zFnAddr("vba6", "EbMode") and replace with zFnAddr("vba5", "EbMode")
End Function

'Return the address of the specified ordinal method on the oCallback object, 1 = last private method, 2 = second last private method, etc
Private Function zAddressOf(ByVal oCallback As Object, ByVal nOrdinal As Long) As Long
    ' Note: used both in subclassing and hooking routines
    Dim bSub  As Byte                                                         'Value we expect to find pointed at by a vTable method entry
    Dim bVal  As Byte
    Dim nAddr As Long                                                         'Address of the vTable
    Dim i     As Long                                                         'Loop index
    Dim J     As Long                                                         'Loop limit
  
    RtlMoveMemory VarPtr(nAddr), ObjPtr(oCallback), 4                         'Get the address of the callback object's instance
    If Not zProbe(nAddr + &H1C, i, bSub) Then                                 'Probe for a Class method
        If Not zProbe(nAddr + &H6F8, i, bSub) Then                              'Probe for a Form method
            ' \\LaVolpe - Added propertypage offset
            If Not zProbe(nAddr + &H710, i, bSub) Then                            'Probe for a PropertyPage method
                If Not zProbe(nAddr + &H7A4, i, bSub) Then                          'Probe for a UserControl method
                    Exit Function                                                   'Bail...
                End If
            End If
        End If
    End If
  
    i = i + 4                                                                 'Bump to the next entry
    J = i + 1024                                                              'Set a reasonable limit, scan 256 vTable entries
    Do While i < J
        RtlMoveMemory VarPtr(nAddr), i, 4                                       'Get the address stored in this vTable entry
    
        If IsBadCodePtr(nAddr) Then                                             'Is the entry an invalid code address?
            RtlMoveMemory VarPtr(zAddressOf), i - (nOrdinal * 4), 4               'Return the specified vTable entry address
            Exit Do                                                               'Bad method signature, quit loop
        End If

        RtlMoveMemory VarPtr(bVal), nAddr, 1                                    'Get the byte pointed to by the vTable entry
        If bVal <> bSub Then                                                    'If the byte doesn't match the expected value...
            RtlMoveMemory VarPtr(zAddressOf), i - (nOrdinal * 4), 4               'Return the specified vTable entry address
            Exit Do                                                               'Bad method signature, quit loop
        End If
    
        i = i + 4                                                               'Next vTable entry
    Loop
End Function

'Probe at the specified start address for a method signature
Private Function zProbe(ByVal nStart As Long, ByRef nMethod As Long, ByRef bSub As Byte) As Boolean
    Dim bVal    As Byte
    Dim nAddr   As Long
    Dim nLimit  As Long
    Dim nEntry  As Long
  
    nAddr = nStart                                                            'Start address
    nLimit = nAddr + 32                                                       'Probe eight entries
    Do While nAddr < nLimit                                                   'While we've not reached our probe depth
        RtlMoveMemory VarPtr(nEntry), nAddr, 4                                  'Get the vTable entry
    
        If nEntry <> 0 Then                                                     'If not an implemented interface
            RtlMoveMemory VarPtr(bVal), nEntry, 1                                 'Get the value pointed at by the vTable entry
            If bVal = &H33 Or bVal = &HE9 Then                                    'Check for a native or pcode method signature
                nMethod = nAddr                                                     'Store the vTable entry
                bSub = bVal                                                         'Store the found method signature
                zProbe = True                                                       'Indicate success
                Exit Do                                                             'Return
            End If
        End If
    
        nAddr = nAddr + 4                                                       'Next vTable entry
    Loop
End Function

Private Function zInIDE() As Long
    ' This is only run in IDE; it is never run when compiled
    z_IDEflag = 1
    zInIDE = z_IDEflag
End Function

Private Property Get zData(ByVal nIndex As Long) As Long
    ' retrieves stored value from virtual function's memory location
    RtlMoveMemory VarPtr(zData), z_ScMem + (nIndex * 4), 4
End Property

Private Property Let zData(ByVal nIndex As Long, ByVal nValue As Long)
    ' sets value in virtual function's memory location
    RtlMoveMemory z_ScMem + (nIndex * 4), VarPtr(nValue), 4
End Property

Private Sub zUnThunk(ByVal thunkID As Long, ByVal vType As eThunkType)
    ' Releases a specific subclass, hook or callback
    ' thunkID depends on vType:
    '   - Subclassing:  the hWnd of the window subclassed
    '   - Hooking:      the hook type created
    '   - Callbacks:    the ordinal of the callback

    Const IDX_SHUTDOWN  As Long = 1
    Const MEM_RELEASE As Long = &H8000&                                'Release allocated memory flag
    
    If zMap_VFunction(thunkID, vType) Then
        Select Case vType
            Case SubclassThunk
                If IsBadCodePtr(z_ScMem) = 0 Then       'Ensure that the thunk hasn't already released its memory
                    zData(IDX_SHUTDOWN) = 1             'Set the shutdown indicator
                    zDelMsg ALL_MESSAGES, IDX_BTABLE    'Delete all before messages
                    zDelMsg ALL_MESSAGES, IDX_ATABLE    'Delete all after messages
                    '\\LaVolpe - Force thunks to replace original window procedure handle. Without this, app can crash when a window is subclassed multiple times simultaneously
                    If zData(IDX_UNICODE) Then          'Force window procedure handle to be replaced
                        SendMessageW thunkID, 0&, 0&, ByVal 0&
                    Else
                        SendMessageA thunkID, 0&, 0&, ByVal 0&
                    End If
                End If
                z_scFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
            Case HookThunk
                If IsBadCodePtr(z_ScMem) = 0 Then       'Ensure that the thunk hasn't already released its memory
                    zData(IDX_SHUTDOWN) = 1             'Set the shutdown indicator
                    zData(IDX_ATABLE) = 0               ' want no more After messages
                    zData(IDX_BTABLE) = 0               ' want no more Before messages
                End If
                z_hkFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
            Case CallbackThunk
                If IsBadCodePtr(z_ScMem) = 0 Then       'Ensure that the thunk hasn't already released its memory
                    VirtualFree z_ScMem, 0, MEM_RELEASE 'Release allocated memory
                End If
                z_cbFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
        End Select
    End If

End Sub

Private Sub zTerminateThunks(ByVal vType As eThunkType)
    ' Removes all thunks of a specific type: subclassing, hooking or callbacks
    Dim i As Long
    Dim thunkCol As Collection
    
    Select Case vType
        Case SubclassThunk
            Set thunkCol = z_scFunk
        Case HookThunk
            Set thunkCol = z_hkFunk
        Case CallbackThunk
            Set thunkCol = z_cbFunk
        Case Else
            Exit Sub
    End Select
    
    If Not (thunkCol Is Nothing) Then                 'Ensure that hooking has been started
        With thunkCol
            For i = .Count To 1 Step -1                   'Loop through the collection of hook types in reverse order
                z_ScMem = .item(i)                          'Get the thunk address
                If IsBadCodePtr(z_ScMem) = 0 Then           'Ensure that the thunk hasn't already released its memory
                    Select Case vType
                        Case SubclassThunk
                            zUnThunk zData(IDX_INDEX), SubclassThunk     'Unsubclass
                        Case HookThunk
                            zUnThunk zData(IDX_INDEX), HookThunk             'Unhook
                        Case CallbackThunk
                            zUnThunk zData(IDX_CALLBACKORDINAL), CallbackThunk ' release callback
                    End Select
                End If
            Next i                                        'Next member of the collection
        End With
        Set thunkCol = Nothing                         'Destroy the hook/thunk-address collection
    End If

End Sub

'=================================================================================
'======================================Toolbar Rutinas'===========================
'=================================================================================

Private Sub DrawToolBar(hwnd As Long)

Dim PT As POINTAPI
Dim PS As PAINTSTRUCT
Dim WinRect As RECT
Dim ButtonRec As RECT
Dim rec As RECT
Dim BtnCount As Integer
Dim i As Integer
Dim TextAlingment As Long
Dim mStr As String
Dim hImageListNormal As Long
Dim IconSize As Size
Dim tSize As Size
Dim hDCMemory As Long
Dim hBmp As Long
Dim DC As Long
Dim TBI As TBBUTTONINFO
Dim InRecButton As Boolean
Dim hFont As Long
Dim sText As String
Dim IconLeft As Long
Dim IconTop As Long
Dim EfectPress As Long
Dim RecText As RECT
Dim DifDropDown As Long
Dim IconState As Long
Dim LastID As Long
Dim BtnWidth As Long
Dim BtnHeight As Long


Call BeginPaint(hwnd, PS)


hImageListNormal = SendMessageLong(hwnd, TB_GETIMAGELIST, 0, 0)
Call ImageList_GetIconSize(hImageListNormal, IconSize.cx, IconSize.cy)

GetWindowRect hwnd, WinRect
DC = GetDC(0)
hDCMemory = CreateCompatibleDC(0)
hBmp = CreateCompatibleBitmap(DC, WinRect.Right - WinRect.Left, WinRect.Bottom - WinRect.Top)
SelectObject hDCMemory, hBmp
SetStretchBltMode hDCMemory, 4
SetBkMode hDCMemory, TRANSPARENT
hFont = SendMessage(hwnd, WM_GETFONT, 0, ByVal 0&)
SelectObject hDCMemory, hFont

DrawBack hDCMemory, WinRect.Right - WinRect.Left, WinRect.Bottom - WinRect.Top

BtnCount = SendMessage(hwnd, TB_BUTTONCOUNT, 0, 0)

LastID = 0


For i = 0 To BtnCount - 1
    
    
    TBI.cbSize = Len(TBI)
    TBI.dwMask = TBIF_ALL
    TBI.idCommand = 0
    
    If m_CommonControls6 Then
        Call SendMessage(hwnd, TB_GETBUTTONINFOA, 100 + i, TBI)
    Else
        Call SendMessage(hwnd, TB_GETBUTTONINFOA, i, TBI)
    End If

      
        If TBI.fsState <> TBSTATE_HIDDEN And TBI.fsState <> (TBSTATE_HIDDEN + TBSTATE_ENABLED) Then
           
            SendMessage hwnd, TB_GETITEMRECT, i, rec

            BtnWidth = rec.Right - rec.Left
            If m_CommonControls6 Then
                BtnHeight = rec.Bottom - rec.Top - AjustBtnHeight
            Else
                BtnHeight = rec.Bottom - rec.Top
            End If
            
            SetRect ButtonRec, WinRect.Left + rec.Left, WinRect.Top + rec.Top, WinRect.Left + rec.Right, WinRect.Top + rec.Bottom
            
            GetCursorPos PT
            InRecButton = PtInRect(ButtonRec, PT.x, PT.y)
                If InRecButton Then
                
                
                
                
                    If TBI.fsStyle = TBSTYLE_DROPDOWN Then '8
                        Select Case TBI.fsState
                            Case 0
                                DrawArrow hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, False
                            Case TBSTATE_ENABLED '4
                                If PT.x < ButtonRec.Right - SpitBtnWidth Then
                                    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth - SpitBtnWidth, BtnHeight, SplitButton, TS_HOT
                                    DrawButton hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, SplitButtonDropDown, TS_HOT
                                Else
                                    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth - SpitBtnWidth, BtnHeight, SplitButton, TS_HOT
                                    If IsWindowVisible(FindWindow("#32768", vbNullString)) Then
                                        DrawButton hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, SplitButtonDropDown, TS_PRESSED
                                    Else
                                        DrawButton hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, SplitButtonDropDown, TS_HOT
                                    End If
                                End If
                            Case TBSTATE_ENABLED Or TBSTATE_PRESSED '5
                                DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth - SpitBtnWidth, BtnHeight, SplitButton, TS_PRESSED
                                DrawButton hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, SplitButtonDropDown, TS_PRESSED
                        End Select
                    Else
                        Select Case TBI.fsState
                            
                            Case TBSTATE_ENABLED, 36 '4
                                 DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_HOT
                                 
                            Case TBSTATE_ENABLED Or TBSTATE_CHECKED '5
                                'If TBI.fsStyle <> TBSTYLE_CHECKGROUP Then
                                    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_HOTCHECKED
                                'Else
                                '    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_CHECKED
                                'End If
                            Case TBSTATE_ENABLED Or TBSTATE_PRESSED, 38 '6
                                'If TBI.fsStyle <> TBSTYLE_CHECKGROUP Then
                                     DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_PRESSED
                                
                                'Else
                                '    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_CHECKED
                                'End If
                            Case TBSTATE_ENABLED Or TBSTATE_PRESSED Or TBSTATE_CHECKED  '7
                                If TBI.fsStyle <> TBSTYLE_CHECKGROUP Then
                                     DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_PRESSED
                                Else
                                    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_HOTCHECKED
                                End If
                                
                        End Select
                    End If
            Else
                If TBI.fsState = TBSTATE_ENABLED + TBSTATE_CHECKED Or TBI.fsState = TBSTATE_ENABLED + TBSTATE_PRESSED + TBSTATE_CHECKED Then '5,7
                    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Default, TS_CHECKED
                End If
            End If
             
                If TBI.fsStyle = TBSTYLE_SEP Then
                    DrawButton hDCMemory, rec.Left, rec.Top, BtnWidth, BtnHeight, Separator
                Else
                    
                    If TBI.fsStyle = TBSTYLE_DROPDOWN Then
                        If TBI.fsState = 0 Then
                            DrawArrow hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, False
                        Else
                             DrawArrow hDCMemory, rec.Right - SpitBtnWidth, rec.Top, SpitBtnWidth, BtnHeight, True
                        End If
                    End If
    
                    DifDropDown = IIf(TBI.fsStyle = TBSTYLE_DROPDOWN, -SpitBtnWidth, 0)
                    
                    If TBI.fsState = (TBSTATE_ENABLED + TBSTATE_PRESSED) Or TBI.fsState = (TBSTATE_ENABLED + TBSTATE_PRESSED + TBSTATE_CHECKED) Or TBI.fsState = TBSTATE_ENABLED + TBSTATE_CHECKED Then
                        
                        EfectPress = 1
                        IconState = 2
                        
                        If TBI.fsStyle <> TBSTYLE_CHECKGROUP Then
                            If TBI.fsState <> TBSTATE_ENABLED + TBSTATE_CHECKED Then
                                SetTextColor hDCMemory, m_TextResalteColor
                            Else
                                SetTextColor hDCMemory, m_TextNormalColor
                            End If
                        End If
                    Else
                        EfectPress = 0
                        If TBI.fsState < TBSTATE_ENABLED Then
                            
                            SetTextColor hDCMemory, m_TextDisabledColor
                            IconState = 0
                            'TBI.fsState = TBSTATE_PRESSED Or TBI.fsState = TBSTATE_CHECKED
                        Else
                            
                            SetTextColor hDCMemory, m_TextNormalColor
                            IconState = 1
                        End If
                        
                    End If
                    
                    If i = 0 And TBI.fsState = (TBSTATE_ENABLED + TBSTATE_CHECKED) Or (TBSTATE_ENABLED + TBSTATE_PRESSED) Then
                        SetTextColor hDCMemory, m_TextResalteColor
                    End If
                    
                    If m_TextAlignRight Then
                        IconLeft = rec.Left + EfectPress + 4
                        IconTop = rec.Top + ((rec.Bottom - rec.Top) / 2) - (IconSize.cy / 2) + EfectPress - 1
                        sText = GetButtonText(hwnd, TBI.idCommand)
                        GetTextExtentPoint32 hDCMemory, sText, Len(sText), tSize
                        SetRect RecText, rec.Left, rec.Top + ((rec.Bottom - rec.Top) / 2) - (tSize.cy / 2) + EfectPress, rec.Right - 4 + DifDropDown + EfectPress, rec.Bottom
                        DrawTextEx hDCMemory, sText, Len(sText), RecText, DT_WORDBREAK Or DT_RIGHT, ByVal 0&
                    Else
                        IconLeft = rec.Left + ((BtnWidth + DifDropDown) / 2) - (IconSize.cx / 2) + EfectPress * 2
                        IconTop = rec.Top + 2 + EfectPress
                        sText = GetButtonText(hwnd, TBI.idCommand)
                        GetTextExtentPoint32 hDCMemory, sText, Len(sText), tSize
                        SetRect RecText, rec.Left + EfectPress * 2, (rec.Bottom - tSize.cy) - 6 + EfectPress, rec.Right + DifDropDown, rec.Bottom
                        DrawTextEx hDCMemory, sText, Len(sText), RecText, DT_WORDBREAK Or DT_CENTER, ByVal 0&
                    End If
                    
                    If InRecButton Then IconState = 2

                    DrawIcon hwnd, TBI.iImage, IconLeft, IconTop, hDCMemory, IconState
                    

            End If
        End If
    
Next

StretchBlt PS.hdc, 0, 0, WinRect.Right, WinRect.Bottom, hDCMemory, 0, 0, WinRect.Right, WinRect.Bottom, vbSrcCopy

Call EndPaint(hwnd, PS)
DeleteObject hBmp
DeleteDC DC
DeleteDC hDCMemory
End Sub

Private Sub DrawIcon(ByVal hTooBar As Long, ByVal IdImage As Long, ByVal Left As Long, ByVal Top As Long, ByVal DestHdc As Long, ByVal State As Long)
Dim hImageList As Long
Dim hIcon As Long

    Select Case State
        Case 0
            hImageList = SendMessageLong(hTooBar, TB_GETDISABLEDIMAGELIST, 0, 0)
            If hImageList Then
                ImageList_Draw hImageList, IdImage, DestHdc, Left, Top, ILD_TRANSPARENT
            Else
                hImageList = SendMessageLong(hTooBar, TB_GETIMAGELIST, 0, 0)
                hIcon = ImageList_GetIcon(hImageList, IdImage, ILD_TRANSPARENT)
                DrawState DestHdc, 0, 0, hIcon, 0, Left, Top, 0, 0, DST_ICON Or DSS_DISABLED
                DestroyIcon hIcon
            End If
        Case 1
            hImageList = SendMessageLong(hTooBar, TB_GETIMAGELIST, 0, 0)
            ImageList_Draw hImageList, IdImage, DestHdc, Left, Top, ILD_TRANSPARENT
        Case 2
            hImageList = SendMessageLong(hTooBar, TB_GETHOTIMAGELIST, 0, 0)
            If hImageList = 0 Then
                hImageList = SendMessageLong(hTooBar, TB_GETIMAGELIST, 0, 0)
            End If
            ImageList_Draw hImageList, IdImage, DestHdc, Left, Top, ILD_TRANSPARENT

    End Select
End Sub

Private Sub DrawButton(ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal Width As Long, ByVal Height As Long, ButtonType As ButtonType, Optional ButtonState As ButtonState)

Dim DC As Long
Dim hDCMemory As Long
Dim hBmp As Long
Dim SampleLeft As Long

DC = GetDC(0)
hDCMemory = CreateCompatibleDC(0)
hBmp = CreateCompatibleBitmap(DC, Width, Height)
Call SelectObject(hDCMemory, hBmp)
SetStretchBltMode hDCMemory, 4

SampleLeft = (SkinBtnWidth * ButtonType) + (SkinBtnWidth * ButtonState)


If ButtonType = Separator Then
    BitBlt hDCMemory, 0, 0, Width, 7, hSkin, 187, 0, vbSrcCopy
    StretchBlt hDCMemory, 0, 7, Width, Height - 7 * 2, hSkin, 187, 7, Width, 9, vbSrcCopy
    BitBlt hDCMemory, 0, Height - 7, Width, 7, hSkin, 187, 16, vbSrcCopy
Else
    BitBlt hDCMemory, 0, 0, SkinBtnBorderW, SkinBtnBorderH, hSkin, SampleLeft, 0, vbSrcCopy
    BitBlt hDCMemory, Width - SkinBtnBorderW, 0, SkinBtnBorderW, SkinBtnBorderH, hSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, 0, vbSrcCopy
    StretchBlt hDCMemory, SkinBtnBorderW, 0, Width - SkinBtnBorderW * 2, SkinBtnBorderH, hSkin, SampleLeft + SkinBtnBorderW, 0, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnBorderH, vbSrcCopy
    StretchBlt hDCMemory, 0, SkinBtnBorderH, SkinBtnBorderW, Height - SkinBtnBorderH * 2, hSkin, SampleLeft, SkinBtnBorderH, SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy
    StretchBlt hDCMemory, SkinBtnBorderW, SkinBtnBorderH, Width - SkinBtnBorderW * 2, Height - SkinBtnBorderH * 2, hSkin, SampleLeft + SkinBtnBorderW, SkinBtnBorderH, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy
    StretchBlt hDCMemory, Width - SkinBtnBorderW, SkinBtnBorderH, SkinBtnBorderW, Height - SkinBtnBorderH * 2, hSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, SkinBtnBorderH, SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy
    BitBlt hDCMemory, 0, Height - SkinBtnBorderH, SkinBtnBorderW, SkinBtnBorderH, hSkin, SampleLeft, SkinBtnHeight - SkinBtnBorderH, vbSrcCopy
    StretchBlt hDCMemory, SkinBtnBorderW, Height - SkinBtnBorderH, Width - SkinBtnBorderW * 2, SkinBtnBorderH, hSkin, SampleLeft + SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH, SkinBtnWidth - SkinBtnBorderW * 2, SkinBtnBorderH, vbSrcCopy
    BitBlt hDCMemory, Width - SkinBtnBorderW, Height - SkinBtnBorderH, SkinBtnBorderW, SkinBtnBorderH, hSkin, SampleLeft + SkinBtnWidth - SkinBtnBorderW, SkinBtnHeight - SkinBtnBorderH, vbSrcCopy
End If
TransparentBlt hdc, x, y, Width, Height, hDCMemory, 0, 0, Width, Height, vbMagenta



If ButtonType = SplitButtonDropDown Then
    DrawArrow hdc, x, y, Width, Height, True
End If

DeleteDC DC
DeleteDC hDCMemory
DeleteObject hBmp
End Sub

Private Sub DrawArrow(ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal Width As Long, ByVal Height As Long, Enabled As Boolean)
    TransparentBlt hdc, x + (Width / 2) - 4, y + (Height / 2) - 3, 7, 7, hSkin, 180, IIf(Enabled, 0, 7), 7, 7, vbMagenta
End Sub

Private Sub DrawBack(ByVal hdc As Long, Width As Long, ByVal Height As Long)
StretchBlt hdc, 0, 0, Width, SkinBtnBorderH, hSkin, 195, 0, SkinBtnWidth, SkinBtnBorderH, vbSrcCopy
StretchBlt hdc, 0, SkinBtnBorderH, Width, Height - SkinBtnBorderH * 2, hSkin, 195, SkinBtnBorderH, SkinBtnWidth, SkinBtnHeight - SkinBtnBorderH * 2, vbSrcCopy
StretchBlt hdc, 0, Height - SkinBtnBorderH, Width, SkinBtnBorderH, hSkin, 195, SkinBtnHeight - SkinBtnBorderH, SkinBtnWidth, SkinBtnBorderH, vbSrcCopy
End Sub

Private Function GetButtonText(ByVal hwnd As Long, ByVal ButtonID As Long) As String
    Dim strButonText As String
    Dim Ret As Long
    
    strButonText = Space(32)
    Call SendMessage(hwnd, TB_GETBUTTONTEXTA, ButtonID, ByVal strButonText)
    Ret = InStr(strButonText, vbNullChar)
    If Ret Then
        GetButtonText = Left(strButonText, Ret - 1)
    End If
End Function



'- ordinal #1
Private Sub WndProc(ByVal bBefore As Boolean, _
       ByRef bHandled As Boolean, _
       ByRef lReturn As Long, _
       ByVal hwnd As Long, _
       ByVal uMsg As Long, _
       ByVal wParam As Long, _
       ByVal lParam As Long, _
       ByRef lParamUser As Long)


If uMsg = WM_PAINT Then DrawToolBar hwnd

If uMsg = WM_ERASEBKGND Then bHandled = True


    
End Sub



