VERSION 5.00
Begin VB.UserControl ctlDownload 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   960
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   960
   InvisibleAtRuntime=   -1  'True
   Picture         =   "ctlAsyncDownload.ctx":0000
   ScaleHeight     =   960
   ScaleWidth      =   960
End
Attribute VB_Name = "ctlDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' This component doesn't require any external calls/apis/references
' Obtains an url to a byte array using native VB6 calls
' Asyncronous - no need to wait for data to arrive
' Multiple downloads are accepted at the same time (different URL's, etc)
' If you like this code, please VOTE for it
' You may use this code freely in your projects, but whenever possible,
' include my name 'Filipe Lage' on the 'Help->About' or something ;)
' Cheers :)
'
' Filipe Lage
' fclage@ezlinkng.com
'

' Constantes para SetWindowPos
Const SWP_FRAMECHANGED = &H20
Const SWP_NOMOVE = &H2
Const SWP_NOZORDER = &H4
Const SWP_NOSIZE = &H1
Const SWP_Flags = SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOSIZE

Private Const WM_SETREDRAW As Long = &HB&

Public Event Progress(x As AsyncProperty, percent As Single)
Public Event Finished(x As AsyncProperty)
Public CurrentDownloads As New Collection

Public AsyncOptionDownload As AsyncReadConstants


Public Function Download(xurl As String) As Boolean
    On Error GoTo error_handler
    UserControl.AsyncRead xurl, vbAsyncTypeByteArray, xurl, AsyncOptionDownload
    CurrentDownloads.Add xurl, xurl
    Exit Function
error_handler:
    If Err.Number <> 693 Then
       If App.LogMode = 0 Then
          MsgBox Err.Description, vbCritical, "Error en la sub Download del UC"
       Else
          Err.Raise Err.Number, "UC Download", Err.Description
       End If
    End If
End Function

Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
    RaiseEvent Finished(AsyncProp)
    On Error Resume Next
    CurrentDownloads.Remove AsyncProp.PropertyName
    On Error GoTo 0
End Sub

Private Sub UserControl_AsyncReadProgress(AsyncProp As AsyncProperty)
    
    Dim p As Single
    If AsyncProp.BytesMax > 0 Then
        p = 100 * (AsyncProp.BytesRead / AsyncProp.BytesMax)
    Else
        p = 0
    End If
    
    RaiseEvent Progress(AsyncProp, p)
End Sub

Private Sub UserControl_Resize()
    UserControl.Width = 960
    UserControl.Height = 960
End Sub

Public Sub CancelAllDownload()
On Error GoTo error_handler

    Do Until CurrentDownloads.Count = 0
        CancelDownload CurrentDownloads(1)
    Loop
    Exit Sub
error_handler:

End Sub

Public Sub CancelDownload(xurl As String)
    On Error Resume Next
    UserControl.CancelAsyncRead CurrentDownloads(xurl)
    CurrentDownloads.Remove xurl
    On Error GoTo 0
    
End Sub

Private Sub UserControl_Terminate()
    Me.CancelAllDownload
End Sub
Private Function UIMode() As Boolean
    On Error Resume Next
    Err.Clear
    UIMode = (Err.Number <> 0)
    On Error GoTo 0
End Function
